module mux32_2 (
	input [31:0] a, b,
	input [0:0] sel,
	output reg [31:0] out
);
	always @(*) begin
		case (sel)
			1'd0: out <= a;
			1'd1: out <= b;
		endcase
	end
endmodule
module mux32_4 (
	input [31:0] a, b, c, d,
	input [1:0] sel,
	output reg [31:0] out
);
	always @(*) begin
		case (sel)
			2'd0: out <= a;
			2'd1: out <= b;
			2'd2: out <= c;
			2'd3: out <= d;
		endcase
	end
endmodule
module reg32 (
    input clk,
    input reset,
    input [31:0] d,
    output reg [31:0] q
);
    always @(posedge clk or posedge reset) begin
        if (reset)
            q <= 32'd0;
        else
            q <= d;
    end
endmodule